• Home
  • Line#
  • Scopes#
  • Navigate#
  • Raw
  • Download
1# SPDX-License-Identifier: GPL-2.0
2####
3# kbuild: Generic definitions
4
5# Convenient variables
6comma   := ,
7quote   := "
8squote  := '
9empty   :=
10space   := $(empty) $(empty)
11space_escape := _-_SPACE_-_
12pound := \#
13
14###
15# Name of target with a '.' as filename prefix. foo/bar.o => foo/.bar.o
16dot-target = $(dir $@).$(notdir $@)
17
18###
19# The temporary file to save gcc -MMD generated dependencies must not
20# contain a comma
21depfile = $(subst $(comma),_,$(dot-target).d)
22
23###
24# filename of target with directory and extension stripped
25basetarget = $(basename $(notdir $@))
26
27###
28# real prerequisites without phony targets
29real-prereqs = $(filter-out $(PHONY), $^)
30
31###
32# Escape single quote for use in echo statements
33escsq = $(subst $(squote),'\$(squote)',$1)
34
35###
36# Quote a string to pass it to C files. foo => '"foo"'
37stringify = $(squote)$(quote)$1$(quote)$(squote)
38
39###
40# Easy method for doing a status message
41       kecho := :
42 quiet_kecho := echo
43silent_kecho := :
44kecho := $($(quiet)kecho)
45
46###
47# filechk is used to check if the content of a generated file is updated.
48# Sample usage:
49#
50# filechk_sample = echo $(KERNELRELEASE)
51# version.h: FORCE
52#	$(call filechk,sample)
53#
54# The rule defined shall write to stdout the content of the new file.
55# The existing file will be compared with the new one.
56# - If no file exist it is created
57# - If the content differ the new file is used
58# - If they are equal no change, and no timestamp update
59define filechk
60	$(Q)set -e;						\
61	mkdir -p $(dir $@);					\
62	trap "rm -f $(dot-target).tmp" EXIT;			\
63	{ $(filechk_$(1)); } > $(dot-target).tmp;		\
64	if [ ! -r $@ ] || ! cmp -s $@ $(dot-target).tmp; then	\
65		$(kecho) '  UPD     $@';			\
66		mv -f $(dot-target).tmp $@;			\
67	fi
68endef
69
70######
71# gcc support functions
72# See documentation in Documentation/kbuild/makefiles.rst
73
74# cc-cross-prefix
75# Usage: CROSS_COMPILE := $(call cc-cross-prefix, m68k-linux-gnu- m68k-linux-)
76# Return first <prefix> where a <prefix>gcc is found in PATH.
77# If no gcc found in PATH with listed prefixes return nothing
78#
79# Note: '2>/dev/null' is here to force Make to invoke a shell. Otherwise, it
80# would try to directly execute the shell builtin 'command'. This workaround
81# should be kept for a long time since this issue was fixed only after the
82# GNU Make 4.2.1 release.
83cc-cross-prefix = $(firstword $(foreach c, $(1), \
84			$(if $(shell command -v -- $(c)gcc 2>/dev/null), $(c))))
85
86# output directory for tests below
87TMPOUT = $(if $(KBUILD_EXTMOD),$(firstword $(KBUILD_EXTMOD))/).tmp_$$$$
88
89# try-run
90# Usage: option = $(call try-run, $(CC)...-o "$$TMP",option-ok,otherwise)
91# Exit code chooses option. "$$TMP" serves as a temporary file and is
92# automatically cleaned up.
93try-run = $(shell set -e;		\
94	TMP=$(TMPOUT)/tmp;		\
95	TMPO=$(TMPOUT)/tmp.o;		\
96	mkdir -p $(TMPOUT);		\
97	trap "rm -rf $(TMPOUT)" EXIT;	\
98	if ($(1)) >/dev/null 2>&1;	\
99	then echo "$(2)";		\
100	else echo "$(3)";		\
101	fi)
102
103# as-option
104# Usage: cflags-y += $(call as-option,-Wa$(comma)-isa=foo,)
105
106as-option = $(call try-run,\
107	$(CC) $(KBUILD_CFLAGS) $(1) -c -x assembler /dev/null -o "$$TMP",$(1),$(2))
108
109# as-instr
110# Usage: cflags-y += $(call as-instr,instr,option1,option2)
111
112as-instr = $(call try-run,\
113	printf "%b\n" "$(1)" | $(CC) $(KBUILD_AFLAGS) -c -x assembler -o "$$TMP" -,$(2),$(3))
114
115# __cc-option
116# Usage: MY_CFLAGS += $(call __cc-option,$(CC),$(MY_CFLAGS),-march=winchip-c6,-march=i586)
117__cc-option = $(call try-run,\
118	$(1) -Werror $(2) $(3) -c -x c /dev/null -o "$$TMP",$(3),$(4))
119
120# cc-option
121# Usage: cflags-y += $(call cc-option,-march=winchip-c6,-march=i586)
122
123cc-option = $(call __cc-option, $(CC),\
124	$(KBUILD_CPPFLAGS) $(KBUILD_CFLAGS),$(1),$(2))
125
126# cc-option-yn
127# Usage: flag := $(call cc-option-yn,-march=winchip-c6)
128cc-option-yn = $(call try-run,\
129	$(CC) -Werror $(KBUILD_CPPFLAGS) $(KBUILD_CFLAGS) $(1) -c -x c /dev/null -o "$$TMP",y,n)
130
131# cc-disable-warning
132# Usage: cflags-y += $(call cc-disable-warning,unused-but-set-variable)
133cc-disable-warning = $(call try-run,\
134	$(CC) -Werror $(KBUILD_CPPFLAGS) $(KBUILD_CFLAGS) -W$(strip $(1)) -c -x c /dev/null -o "$$TMP",-Wno-$(strip $(1)))
135
136# cc-ifversion
137# Usage:  EXTRA_CFLAGS += $(call cc-ifversion, -lt, 0402, -O1)
138cc-ifversion = $(shell [ $(CONFIG_GCC_VERSION)0 $(1) $(2)000 ] && echo $(3) || echo $(4))
139
140# ld-option
141# Usage: KBUILD_LDFLAGS += $(call ld-option, -X, -Y)
142ld-option = $(call try-run, $(LD) $(KBUILD_LDFLAGS) $(1) -v,$(1),$(2),$(3))
143
144# ld-version
145# Note this is mainly for HJ Lu's 3 number binutil versions
146ld-version = $(shell $(LD) --version | $(srctree)/scripts/ld-version.sh)
147
148# ld-ifversion
149# Usage:  $(call ld-ifversion, -ge, 22252, y)
150ld-ifversion = $(shell [ $(ld-version) $(1) $(2) ] && echo $(3) || echo $(4))
151
152######
153
154###
155# Shorthand for $(Q)$(MAKE) -f scripts/Makefile.build obj=
156# Usage:
157# $(Q)$(MAKE) $(build)=dir
158build := -f $(srctree)/scripts/Makefile.build obj
159
160###
161# Shorthand for $(Q)$(MAKE) -f scripts/Makefile.dtbinst obj=
162# Usage:
163# $(Q)$(MAKE) $(dtbinst)=dir
164dtbinst := -f $(srctree)/scripts/Makefile.dtbinst obj
165
166###
167# Shorthand for $(Q)$(MAKE) -f scripts/Makefile.clean obj=
168# Usage:
169# $(Q)$(MAKE) $(clean)=dir
170clean := -f $(srctree)/scripts/Makefile.clean obj
171
172# echo command.
173# Short version is used, if $(quiet) equals `quiet_', otherwise full one.
174echo-cmd = $(if $($(quiet)cmd_$(1)),\
175	echo '  $(call escsq,$($(quiet)cmd_$(1)))$(echo-why)';)
176
177# sink stdout for 'make -s'
178       redirect :=
179 quiet_redirect :=
180silent_redirect := exec >/dev/null;
181
182# Delete the target on interruption
183#
184# GNU Make automatically deletes the target if it has already been changed by
185# the interrupted recipe. So, you can safely stop the build by Ctrl-C (Make
186# will delete incomplete targets), and resume it later.
187#
188# However, this does not work when the stderr is piped to another program, like
189#  $ make >&2 | tee log
190# Make dies with SIGPIPE before cleaning the targets.
191#
192# To address it, we clean the target in signal traps.
193#
194# Make deletes the target when it catches SIGHUP, SIGINT, SIGQUIT, SIGTERM.
195# So, we cover them, and also SIGPIPE just in case.
196#
197# Of course, this is unneeded for phony targets.
198delete-on-interrupt = \
199	$(if $(filter-out $(PHONY), $@), \
200		$(foreach sig, HUP INT QUIT TERM PIPE, \
201			trap 'rm -f $@; trap - $(sig); kill -s $(sig) $$$$' $(sig);))
202
203# printing commands
204cmd = @set -e; $(echo-cmd) $($(quiet)redirect) $(delete-on-interrupt) $(cmd_$(1))
205
206###
207# if_changed      - execute command if any prerequisite is newer than
208#                   target, or command line has changed
209# if_changed_dep  - as if_changed, but uses fixdep to reveal dependencies
210#                   including used config symbols
211# if_changed_rule - as if_changed but execute rule instead
212# See Documentation/kbuild/makefiles.rst for more info
213
214ifneq ($(KBUILD_NOCMDDEP),1)
215# Check if both commands are the same including their order. Result is empty
216# string if equal. User may override this check using make KBUILD_NOCMDDEP=1
217cmd-check = $(filter-out $(subst $(space),$(space_escape),$(strip $(cmd_$@))), \
218                         $(subst $(space),$(space_escape),$(strip $(cmd_$1))))
219else
220cmd-check = $(if $(strip $(cmd_$@)),,1)
221endif
222
223# Replace >$< with >$$< to preserve $ when reloading the .cmd file
224# (needed for make)
225# Replace >#< with >$(pound)< to avoid starting a comment in the .cmd file
226# (needed for make)
227# Replace >'< with >'\''< to be able to enclose the whole string in '...'
228# (needed for the shell)
229make-cmd = $(call escsq,$(subst $(pound),$$(pound),$(subst $$,$$$$,$(cmd_$(1)))))
230
231# Find any prerequisites that are newer than target or that do not exist.
232# (This is not true for now; $? should contain any non-existent prerequisites,
233# but it does not work as expected when .SECONDARY is present. This seems a bug
234# of GNU Make.)
235# PHONY targets skipped in both cases.
236newer-prereqs = $(filter-out $(PHONY),$?)
237
238# Execute command if command has changed or prerequisite(s) are updated.
239if_changed = $(if $(newer-prereqs)$(cmd-check),                              \
240	$(cmd);                                                              \
241	printf '%s\n' 'cmd_$@ := $(make-cmd)' > $(dot-target).cmd, @:)
242
243# Execute the command and also postprocess generated .d dependencies file.
244if_changed_dep = $(if $(newer-prereqs)$(cmd-check),$(cmd_and_fixdep),@:)
245
246cmd_and_fixdep =                                                             \
247	$(cmd);                                                              \
248	scripts/basic/fixdep $(depfile) $@ '$(make-cmd)' > $(dot-target).cmd;\
249	rm -f $(depfile)
250
251# Usage: $(call if_changed_rule,foo)
252# Will check if $(cmd_foo) or any of the prerequisites changed,
253# and if so will execute $(rule_foo).
254if_changed_rule = $(if $(newer-prereqs)$(cmd-check),$(rule_$(1)),@:)
255
256###
257# why - tell why a target got built
258#       enabled by make V=2
259#       Output (listed in the order they are checked):
260#          (1) - due to target is PHONY
261#          (2) - due to target missing
262#          (3) - due to: file1.h file2.h
263#          (4) - due to command line change
264#          (5) - due to missing .cmd file
265#          (6) - due to target not in $(targets)
266# (1) PHONY targets are always build
267# (2) No target, so we better build it
268# (3) Prerequisite is newer than target
269# (4) The command line stored in the file named dir/.target.cmd
270#     differed from actual command line. This happens when compiler
271#     options changes
272# (5) No dir/.target.cmd file (used to store command line)
273# (6) No dir/.target.cmd file and target not listed in $(targets)
274#     This is a good hint that there is a bug in the kbuild file
275ifeq ($(KBUILD_VERBOSE),2)
276why =                                                                        \
277    $(if $(filter $@, $(PHONY)),- due to target is PHONY,                    \
278        $(if $(wildcard $@),                                                 \
279            $(if $(newer-prereqs),- due to: $(newer-prereqs),                \
280                $(if $(cmd-check),                                           \
281                    $(if $(cmd_$@),- due to command line change,             \
282                        $(if $(filter $@, $(targets)),                       \
283                            - due to missing .cmd file,                      \
284                            - due to $(notdir $@) not in $$(targets)         \
285                         )                                                   \
286                     )                                                       \
287                 )                                                           \
288             ),                                                              \
289             - due to target missing                                         \
290         )                                                                   \
291     )
292
293echo-why = $(call escsq, $(strip $(why)))
294endif
295
296###############################################################################
297#
298# When a Kconfig string contains a filename, it is suitable for
299# passing to shell commands. It is surrounded by double-quotes, and
300# any double-quotes or backslashes within it are escaped by
301# backslashes.
302#
303# This is no use for dependencies or $(wildcard). We need to strip the
304# surrounding quotes and the escaping from quotes and backslashes, and
305# we *do* need to escape any spaces in the string. So, for example:
306#
307# Usage: $(eval $(call config_filename,FOO))
308#
309# Defines FOO_FILENAME based on the contents of the CONFIG_FOO option,
310# transformed as described above to be suitable for use within the
311# makefile.
312#
313# Also, if the filename is a relative filename and exists in the source
314# tree but not the build tree, define FOO_SRCPREFIX as $(srctree)/ to
315# be prefixed to *both* command invocation and dependencies.
316#
317# Note: We also print the filenames in the quiet_cmd_foo text, and
318# perhaps ought to have a version specially escaped for that purpose.
319# But it's only cosmetic, and $(patsubst "%",%,$(CONFIG_FOO)) is good
320# enough.  It'll strip the quotes in the common case where there's no
321# space and it's a simple filename, and it'll retain the quotes when
322# there's a space. There are some esoteric cases in which it'll print
323# the wrong thing, but we don't really care. The actual dependencies
324# and commands *do* get it right, with various combinations of single
325# and double quotes, backslashes and spaces in the filenames.
326#
327###############################################################################
328#
329define config_filename
330ifneq ($$(CONFIG_$(1)),"")
331$(1)_FILENAME := $$(subst \\,\,$$(subst \$$(quote),$$(quote),$$(subst $$(space_escape),\$$(space),$$(patsubst "%",%,$$(subst $$(space),$$(space_escape),$$(CONFIG_$(1)))))))
332ifneq ($$(patsubst /%,%,$$(firstword $$($(1)_FILENAME))),$$(firstword $$($(1)_FILENAME)))
333else
334ifeq ($$(wildcard $$($(1)_FILENAME)),)
335ifneq ($$(wildcard $$(srctree)/$$($(1)_FILENAME)),)
336$(1)_SRCPREFIX := $(srctree)/
337endif
338endif
339endif
340endif
341endef
342#
343###############################################################################
344
345# delete partially updated (i.e. corrupted) files on error
346.DELETE_ON_ERROR:
347
348# do not delete intermediate files automatically
349.SECONDARY:
350